package cpcns.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.configuration.AppConfiguration;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.context.ContextLoader;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

public class UploadUtil {
  public static String sqlUrl;
  
  private static String sqlFile() {
    if (StringUtils.isBlank(sqlUrl))
      sqlUrl = 
        AppConfiguration.getConfigValue("sqlFile_url"); 
    return sqlUrl;
  }
  
  public static List<Map<String, Object>> saveOldFileName(MultipartHttpServletRequest multipartRequest, String saveUrl, String viewUrl) {
    List<Map<String, Object>> resutlList = new ArrayList<>();
    try {
      OutputStream out = null;
      String responStr = "";
      String flag = "";
      List<MultipartFile> mpfList = multipartRequest.getFiles("upload");
      String oldfileName = "";
      for (MultipartFile mf : mpfList) {
        Map<String, Object> result = new HashMap<>();
        oldfileName = mf.getOriginalFilename();
        if (StringUtils.isNotBlank(oldfileName)) {
          String extensionName = oldfileName.substring(oldfileName.lastIndexOf(".") + 1);
          Long size = Long.valueOf(mf.getSize());
          try {
            out = new FileOutputStream(new File(getSaveRealPicFileWholeSavePath(extensionName, saveUrl), oldfileName));
            System.gc();
            IOUtils.copy(mf.getInputStream(), out);
            IOUtils.closeQuietly(out);
            out.close();
            flag = "1";
            responStr = "上传成功";
          } catch (Exception e) {
            System.out.println(e.getMessage());
            flag = "0";
            responStr = "上传失败";
          } finally {
            IOUtils.closeQuietly(out);
          } 
          String url = String.valueOf(getPicFileURL(extensionName, viewUrl)) + oldfileName;
          result.put("flag", flag);
          result.put("msg", responStr);
          result.put("filename", oldfileName);
          result.put("fileSize", size);
          result.put("fileurl", url);
          result.put("filestore", getSaveRealPicFileWholeSavePath(extensionName, saveUrl));
          result.put("fileoldname", oldfileName);
          result.put("extensionName", extensionName);
          resutlList.add(result);
          continue;
        } 
        result.put("flag", Integer.valueOf(0));
        result.put("msg", "上传失败");
        resutlList.add(result);
      } 
    } catch (Exception exception) {}
    return resutlList;
  }
  
  public static List<Map<String, Object>> saveFile(MultipartHttpServletRequest multipartRequest, String saveUrl, String viewUrl) {
    List<Map<String, Object>> resutlList = new ArrayList<>();
    try {
      OutputStream out = null;
      String responStr = "";
      String flag = "";
      List<MultipartFile> mpfList = multipartRequest.getFiles("upload");
      String oldfileName = "";
      for (MultipartFile mf : mpfList) {
        Map<String, Object> result = new HashMap<>();
        oldfileName = mf.getOriginalFilename();
        if (StringUtils.isNotBlank(oldfileName)) {
          String extensionName = oldfileName.substring(oldfileName.lastIndexOf(".") + 1);
          Long size = Long.valueOf(mf.getSize());
          String newFileName = getNewFileName(extensionName);
          try {
            out = new FileOutputStream(new File(getSaveRealPicFileWholeSavePath(extensionName, saveUrl), newFileName));
            System.gc();
            IOUtils.copy(mf.getInputStream(), out);
            IOUtils.closeQuietly(out);
            out.close();
            flag = "1";
            responStr = "上传成功";
          } catch (Exception e) {
            System.out.println(e.getMessage());
            flag = "0";
            responStr = "上传失败";
          } finally {
            IOUtils.closeQuietly(out);
          } 
          String url = String.valueOf(getPicFileURL(extensionName, viewUrl)) + newFileName;
          result.put("flag", flag);
          result.put("msg", responStr);
          result.put("filename", newFileName);
          result.put("fileSize", size);
          result.put("fileurl", url);
          result.put("filestore", getSaveRealPicFileWholeSavePath(extensionName, saveUrl));
          result.put("fileoldname", oldfileName);
          result.put("extensionName", extensionName);
          resutlList.add(result);
          continue;
        } 
        result.put("flag", Integer.valueOf(0));
        result.put("msg", "上传失败");
        resutlList.add(result);
      } 
    } catch (Exception exception) {}
    return resutlList;
  }
  
  public static String getNewFileName(String extensionName) {
    String newFileName = "";
    try {
      newFileName = String.valueOf((new Date()).getTime()) + "." + extensionName;
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return newFileName;
  }
  
  public static String getSaveRealPicFileWholeSavePath(String t_type, String url) {
    String picFileWholeSavePath = "";
    picFileWholeSavePath = url;
    createFolder(picFileWholeSavePath);
    return picFileWholeSavePath;
  }
  
  public static File createFolder(String savePath) {
    File dir = new File(savePath);
    if (!dir.exists())
      dir.mkdirs(); 
    return dir;
  }
  
  public static String getPicFileURL(String t_type, String viewUrl) {
    String picFileWholeSavePath = "";
    picFileWholeSavePath = viewUrl;
    return picFileWholeSavePath;
  }
  
  public static boolean deleteFile(String sPath) {
    boolean flag = false;
    File file = new File(sPath);
    if (file.isFile() && file.exists()) {
      file.delete();
      flag = true;
    } 
    return flag;
  }
  
  public static boolean deleteDirectory(String dir) {
    if (!dir.endsWith(File.separator))
      dir = String.valueOf(dir) + File.separator; 
    File dirFile = new File(dir);
    if (!dirFile.exists() || !dirFile.isDirectory()) {
      System.out.println("删除目录失败：" + dir + "不存在！");
      return false;
    } 
    boolean flag = true;
    File[] files = dirFile.listFiles();
    for (int i = 0; i < files.length; i++) {
      if (files[i].isFile()) {
        flag = deleteFile(files[i].getAbsolutePath());
        if (!flag)
          break; 
      } else if (files[i].isDirectory()) {
        flag = deleteDirectory(files[i]
            .getAbsolutePath());
        if (!flag)
          break; 
      } 
    } 
    if (!flag) {
      System.out.println("删除目录失败！");
      return false;
    } 
    if (dirFile.delete()) {
      System.out.println("删除目录" + dir + "成功！");
      return true;
    } 
    return false;
  }
  
  public static boolean createDir(String destDirName) {
    File dir = new File(destDirName);
    if (dir.exists())
      return false; 
    if (!destDirName.endsWith(File.separator))
      destDirName = String.valueOf(destDirName) + File.separator; 
    if (dir.mkdirs())
      return true; 
    return false;
  }
  
  public Map<String, Object> newSaveImages(HttpServletRequest request, HttpServletResponse response, String saveUrl, String viewUrl, String fileName) {
    Map<String, Object> resultMap = new HashMap<>();
    try {
      DataInputStream in2 = new DataInputStream((InputStream)request.getInputStream());
      request.setCharacterEncoding("utf-8");
      String filePath = saveUrl;
      File fd = new File(filePath);
      if (!fd.exists())
        fd.mkdir(); 
      response.setContentType("application/octest-stream");
      fileName = URLDecoder.decode(fileName, "UTF-8");
      String suffixName = fileName.substring(fileName.lastIndexOf(".") + 1);
      String newFileName = getNewFileName(suffixName);
      File file_out = new File(String.valueOf(filePath) + File.separator + newFileName);
      if (!file_out.exists()) {
        createDir(saveUrl);
        file_out.createNewFile();
      } 
      FileOutputStream byteout = new FileOutputStream(file_out);
      int c = 0;
      byte[] bytes = new byte[1024];
      while ((c = in2.read(bytes)) != -1)
        byteout.write(bytes, 0, c); 
      byteout.flush();
      byteout.close();
      in2.close();
      String url = String.valueOf(getPicFileURL(suffixName, viewUrl)) + newFileName;
      resultMap.put("oldFileName", fileName);
      resultMap.put("newFileName", newFileName);
      resultMap.put("suffixName", suffixName);
      resultMap.put("fielSize", Long.valueOf(fd.length()));
      resultMap.put("fileurl", url);
      resultMap.put("success", Integer.valueOf(0));
      resultMap.put("info", "上传成功");
    } catch (Exception e) {
      System.out.println(e.getMessage());
      resultMap.put("success", Integer.valueOf(1));
      resultMap.put("info", "上传失败");
    } 
    return resultMap;
  }
  
  private static String dealWebAppCiPanPath() {
    String prefix = "";
    String ciPanPath = ContextLoader.getCurrentWebApplicationContext()
      .getServletContext().getRealPath(File.separator);
    if (StringUtils.isNotBlank(ciPanPath) && 
      ciPanPath.contains(File.separator)) {
      String[] strArray = ciPanPath.split("\\" + File.separator);
      if (strArray != null && strArray.length > 0) {
        String webAppName = strArray[strArray.length - 1];
        prefix = ciPanPath.substring(0, 
            ciPanPath.indexOf(webAppName) - 1);
      } 
    } 
    return prefix;
  }
  
  public static String obtainWebPath(String path, HttpServletRequest request) {
    String resultPath = "";
    String webServerPath = "http://" + request.getServerName() + ":" + 
      request.getServerPort();
    resultPath = dealBasePath(webServerPath, path);
    return resultPath;
  }
  
  private static String dealBasePath(String webPath, String path) {
    String prefix = webPath;
    String middlePrefix = sqlFile();
    String rootPath = "";
    if (StringUtils.isNotBlank(prefix))
      rootPath = String.valueOf(prefix) + File.separator; 
    if (StringUtils.isNotBlank(path))
      rootPath = String.valueOf(rootPath) + middlePrefix + File.separator + path; 
    if (File.separator.equals("\\")) {
      rootPath = rootPath.replace("\\", "/");
    } else if (File.separator.equals("/")) {
      rootPath = rootPath.replace("\\", File.separator);
    } 
    return rootPath;
  }
  
  public static String obtainCiPanPath(String path) {
    String resultPath = "";
    String ciPanWebPath = dealWebAppCiPanPath();
    resultPath = dealBasePath(ciPanWebPath, path);
    return resultPath;
  }
}
